;; Predefined functions for minischeme.

(define + (lambda (x y) ($+ x y)))
(define - (lambda (x y) ($- x y)))
(define * (lambda (x y) ($* x y)))
(define / (lambda (x y) ($/ x y)))
(define % (lambda (x y) ($% x y)))

(define = (lambda (x y) ($= x y)))
(define < (lambda (x y) ($< x y)))
(define <= (lambda (x y) ($<= x y)))
(define > (lambda (x y) (if ($< y x) 1 0)))
(define >= (lambda (x y) (if ($<= y x) 1 0)))

(define and (lambda (x y) (if x y 0)))
(define or (lambda (x y) (if x 1 y)))

(define nil 0)
(define cons
  (lambda (fst snd)
    (let ((pair ($alloc 2)))
      ($set pair 0 fst)
      ($set pair 1 snd)
      pair)))
(define car (lambda (pair) ($get pair 0)))
(define cdr (lambda (pair) ($get pair 1)))
(define null? (lambda (pair) (= pair 0)))

(define read-int (lambda () ($read-int)))
(define print-int (lambda (i) ($print-int i)))
(define read-char (lambda () ($read-char)))
(define print-char (lambda (c) ($print-char c)))

(define print-space (lambda () (print-char 32)))
(define newline (lambda () (print-char 10)))
