#ifndef PARSER_H_
#define PARSER_H_

/* The current line number. */
extern int linenr;

#define MAX_LINE 255

/* The current line in the input file. */
extern char line[MAX_LINE];
extern char ident[MAX_LINE];

extern int c;

/* The address in code where we assemble the next instruction. */
extern int pc;

/* Lexemes. */
extern char* identifier();
extern int   opcode();
extern int   reg();
extern int   integer();

/* Non terminals. */
extern void labeldef();

/* Helpers */
extern void handle_label();
extern char *next_line();

extern void skip_whitespace();
extern void error(const char* str);


#endif /*PARSER_H_*/
