#ifndef LOG_H_
#define LOG_H_

#include <stdio.h>

#include "main.h"

#define LOG_FILE "minivm.log"

#define LOG_ERROR 0
#define LOG_INFO  1
#define LOG_WARN  2
#define LOG_DEBUG 3

/* The log file. */
extern FILE* logfile;

/* The current log_level. Only messages logged at a level
 * less than or equal to log_level will be printed in the
 * log file. */
extern int log_level;

/* Return FALSE if the filename could not be open for writing. */
extern int
init_log(const char* filename);

/* Log a message in the log file, using the given level. */
extern void
write_log(int level, const char* str, ...);

#endif /*LOG_H_*/
