/*
 * MiniVM project (c) LAMP 2006
 * 
 * Memory management functions. Allocation and garbage collection.
 * 
 * $Id: memory.c,v 1.1 2006/03/16 15:55:25 dragos Exp $
 */
 
 
#include "../emulator/vm.h"
#include "../main.h"
#include "../log.h"
#include "memory.h"

static int  gc_alloc(int);
static void gc_init();

garbage_collector_t no_gc = {
  &gc_init,
  &gc_alloc
};

/* The next free address, relative to heap_mem. */
int next_free = 0;

void
gc_init()
{
}

int
gc_alloc(int size)
{
  if (next_free + size < heap_size)
    {
      write_log(LOG_DEBUG, "Allocating %d bytes of memory at: 0x%0.8x\n",
                size, (int)(heap_mem + next_free));
      int* mem = (int*)(heap_mem + next_free);
      next_free += size;
      mem[0] = size;
      return (int)mem;
    } else
      {
        printf("Could not allocate %d bytes of memory. No garbage collector. We die.\n", size);
        exit_vm();
      }
  return -1;
}
